<?php

/**
 * Carerix Wordpress Plugin
 *
 * @category settings
 * @author Bogdan Ivanov
 * @copyright Copyright (c) 2013 Carerix.com (http://www.carerix.com)
 * @link http://www.carerix.com
 * @since Jul 25, 2013 12:36:29 PM
 * @version $Rev$
 */


/**
 * Constants class
 * Used to constant
 */
class WP_Constants {
	const M440_DEVMODE = 0; // Leave this to 0 for production environment
	const CAPABILITY_ADMIN = 'administrator';
	const META_KEY_PREFIX = '_carerix_';
	const ADDITIONAL_FIELD_DELETED_KEY = '___::DELETED!!___';
	const ADDITIONAL_FIELD_PREFIX = 'cx_extra_';
    const CARERIX_USER_NICENAME = '- Carerix -';
	const ENTITY_TYPE_CANDIDATE = 'candidate';
	const ENTITY_TYPE_COMPANY = 'company';
	const ENTITY_TYPE_JOB = 'job';
	const ENTITY_TYPE_NEWSLETTER = 'newsletter';
	const ENTITY_TYPE_ARTICLE = 'article';
	const ENTITY_TYPE_PEOPLE = 'people';
	const ENTITY_TYPE_PROMOTIONAL = 'promotional';
	
	const ENTITY_TYPE_FORM_APPLY = 'apply';
	
	const CARERIX_API_ENDPOINT = 'https://api.carerix.com';
	const CARERIX_API_MAX_ATTACHMENT_SIZE_MB = 8; // This is the total size of all files together

	const DEFAULT_LANGUAGE_CODE = 'en-GB';
	
	const DEFAULT_APPLY_PAGE_MARKER = '_apply_default_page';
	
	const DOMAIN_URL_TEMPLATE = 'https://[appname].carerix.com';
	
	const FEED_JOBS = 'cxtools/wp_feed.php';
	const FEED_CANDIDATES = 'cxtools/wp_feed_candidates.php';
	const FEED_PEOPLE = 'cxtools/wp_feed_people.php';
	const FEED_COMPANIES = 'cxtools/wp_feed_companies.php';
	const FEED_NEWSLETTERS = 'cxtools/wp_feed_newsletters.php';
    
    const FEED_RSS_FEED = 'cxtools/RSS.php';
    // 8 * 60 * 60 = 8 hours
    const SYNC_WARNING_TIME = 28800;
    
    const TAXONOMY_COUNTRY = 'country';
//    const TAXONOMY_COUNTRY_SLUG = 'countries';
    
    const TAXONOMY_REGION = 'region';
//    const TAXONOMY_REGION_SLUG = 'regions';
    
    const TAXONOMY_WORKLOCATION = 'worklocation';
//    const TAXONOMY_WORKLOCATION_SLUG = 'work_locations';
    
    const TAXONOMY_EDUCATION = 'education';
//    const TAXONOMY_EDUCATION_SLUG = 'educations';
    
    const TAXONOMY_SECTOR = 'sector'; // FEED = branche0, CX = toVacancy.toBrancheLevel1.value
//    const TAXONOMY_SECTOR_SLUG = 'sector';
    
    const TAXONOMY_INDUSTRY = 'industry'; // FEED = branche1, CX = toVacancy.toBrancheLevel2.value
//    const TAXONOMY_INDUSTRY_SLUG = 'industry';

    const TAXONOMY_FUNCTIONGROUP = 'functiongroups'; // FEED = function0, CX = toVacancy.toFunctionLevel1.value
    const TAXONOMY_FUNCTIONGROUP_SLUG = 'functiongroups';

    const TAXONOMY_FUNCTION = 'functions'; // FEED = function1, CX = toVacancy.toFunctionLevel2.value
//    const TAXONOMY_FUNCTION_SLUG = 'functions';
    
    const TAXONOMY_WORKLEVEL = 'worklevels';
//    const TAXONOMY_WORKLEVEL_SLUG = 'worklevels';
    
    const TAXONOMY_PROCEDURE = 'procedure';
//    const TAXONOMY_PROCEDURE_SLUG = 'procedure';

    const TAXONOMY_BUSINESSLINE = 'business-line';
//    const TAXONOMY_BUSINESSLINE_SLUG = 'business_line';

    const TAXONOMY_CONTRACTTYPE = 'employment-contract';
//    const TAXONOMY_CONTRACTTYPE_SLUG = 'employment_contract';

    const TAXONOMY_JOBGROUP = 'job-group';
//    const TAXONOMY_JOBGROUP_SLUG = 'vacancy_group';

    const TAXONOMY_HOURSPERWEEK = 'hours-per-week';
//    const TAXONOMY_HOURSPERWEEK_SLUG = 'hours_per_week';

    const TAXONOMY_MINSALARY = 'min-salary';
//    const TAXONOMY_MINSALARY_SLUG = 'min_salary';

    const TAXONOMY_MAXSALARY = 'max-salary';
//    const TAXONOMY_MAXSALARY_SLUG = 'max_salary';

    const TAXONOMY_CANDIDATE_EDUCATION_LEVEL_1 = 'candidate-education-level1';
//    const TAXONOMY_CANDIDATE_EDUCATION_LEVEL_1_SLUG = 'candidate_education_level_1';
    
    const TAXONOMY_CANDIDATE_EDUCATION_LEVEL_2 = 'candidate-education-level2';
//    const TAXONOMY_CANDIDATE_EDUCATION_LEVEL_2_SLUG = 'candidate_education_level_2';

    const TAXONOMY_CANDIDATE_EDUCATION_LEVEL_3 = 'candidate-education-level3';
//    const TAXONOMY_CANDIDATE_EDUCATION_LEVEL_3_SLUG = 'candidate_education_level_3';
    
    const TAXONOMY_CANDIDATE_LAND = 'candidate-land';
//    const TAXONOMY_CANDIDATE_LAND_SLUG = 'candidate_countries';
    
    const TAXONOMY_CANDIDATE_REGION = 'candidate-region';
//    const TAXONOMY_CANDIDATE_REGION_SLUG = 'candidate_regions';

    const TAXONOMY_PUBIDLIST = 'pubid-list';


    // for keeping inside 30 secs maximum time of execution
    const NR_OF_ITEMS = 10;
}